// // Listen for the 'notification' event

function handleNotifications() {

  const originalNotification = window.Notification;
  async function notifyCallback(title, opt) {
    const isPermissionGranted = await window.__TAURI__.notification.isPermissionGranted();
    if (!isPermissionGranted) {
      const permission = await window.__TAURI__.notification.requestPermission();
      if (permission !== "granted") {
        return;
      }
    }
    const isMinimized = await window.__TAURI__.window.appWindow.isMinimized();
    if (isMinimized) {
      // find a solution to unminimise window on notification click
      // await window.__TAURI__.window.appWindow.show();
    }

    const n = new originalNotification(title, opt);
    n.onclick = () => {
      // todo
      // find a way to make this work
      console.log("notification clicked");
    };
  }

  const handler = {
    construct(target, args) {
      notifyCallback(...args);
      return new target(...args);
    },
  };

  const ProxifiedNotification = new Proxy(Notification, handler);

  window.Notification = ProxifiedNotification;
}

const handleRefresh = (e) => {
  if (e.key === "r" && (e.metaKey || e.ctrlKey)) {
    window.location.reload();
   }
}

const handleClick = (event) => {
  console.log('event.target; :', event.target.href, event.target.target, event.target.closest('a'));
  const target = event.target.closest('a');
  if (target) {
    const link = event.target.href;
    const anchorTarget = target.target;
    console.log("CLICK REGISTERED", link);
    if(anchorTarget === "_blank" && link) {
      event.preventDefault();
      event.stopPropagation();
      event.stopImmediatePropagation();
    }

  }
}

window.addEventListener("DOMContentLoaded", () => {
  const downloadButton = document.getElementsByTagName("a"); // replace with actual button id

  console.log("DOWNLAOD BUTTON FOUND");
  console.log(downloadButton);

  if (downloadButton && downloadButton.length > 0) {
    downloadButton.addEventListener("click", (event) => {
      // Prevent default behavior
      event.preventDefault();

      // Get download URL
      const url = event.target.href;

      // Send download URL to Rust side
      __TAURI__.invoke("download_file", { url });
    });
  }
});

document.addEventListener("DOMContentLoaded", (e) => {
  e.preventDefault();

  handleNotifications();
  document.addEventListener('keydown', event => {
    handleRefresh(event);
  })
  document.body.addEventListener("contextmenu", function (event) {
    event.preventDefault();
    return false;
  });

  window.__TAURI__.app.getVersion().then((version) => {
    console.log("version", version);
    window.DESKTOP_APP_VERSION = version;
  });

  document.querySelector("body").addEventListener("click", handleClick)
});
